'use client';
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.defaultRenderInput = defaultRenderInput;
exports.renderChildren = renderChildren;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _Input = _interopRequireDefault(require("../Input"));
var _excluded = ["onBlur"];
function defaultRenderInput(props, ref) {
  return /*#__PURE__*/_react.default.createElement(_Input.default, (0, _extends2.default)({
    ref: ref
  }, props));
}
var pickers = ['DatePicker', 'DateRangePicker', 'InputPicker', 'TagPicker', 'Cascader', 'MultiCascader', 'SelectPicker', 'CheckPicker', 'CheckTreePicker', 'TreePicker'];
function getDisplayName(Component) {
  var _Component$type;
  if (typeof (Component === null || Component === void 0 ? void 0 : Component.type) === 'string') {
    return Component === null || Component === void 0 ? void 0 : Component.type;
  }
  return (Component === null || Component === void 0 ? void 0 : (_Component$type = Component.type) === null || _Component$type === void 0 ? void 0 : _Component$type.displayName) || '';
}
function renderChildren(children, props, ref) {
  if (typeof children === 'function') {
    return children(props, ref);
  }
  if (pickers.includes(getDisplayName(children))) {
    var onBlur = props.onBlur,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, _excluded);

    // if the children is a picker, we should pass the onBlur to the onClose
    return /*#__PURE__*/_react.default.cloneElement(children, (0, _extends2.default)({}, rest, {
      onClose: onBlur,
      ref: ref
    }));
  }
  return /*#__PURE__*/_react.default.cloneElement(children, (0, _extends2.default)({}, props, {
    ref: ref
  }));
}