'use client';
"use strict";

exports.__esModule = true;
exports.default = void 0;
exports.useFocusVirtualListItem = useFocusVirtualListItem;
var _react = require("react");
/**
 * Virtualized list loses focus when scrolling or clicking options, causing the component to re-render.
 * To solve this problem, we need to refocus on the selected option after the component is re-rendered.
 */
function useFocusVirtualListItem(focused) {
  var itemRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (!focused) {
      return;
    }
    if (document.activeElement !== itemRef.current) {
      var _itemRef$current;
      // Focus on the selected option.
      (_itemRef$current = itemRef.current) === null || _itemRef$current === void 0 ? void 0 : _itemRef$current.focus();
    }
  }, [focused]);
  return itemRef;
}
var _default = exports.default = useFocusVirtualListItem;