'use client';
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.getReversedTimeMeridian = exports.default = void 0;
var _setHours = _interopRequireDefault(require("date-fns/setHours"));
var _getHours = _interopRequireDefault(require("date-fns/getHours"));
/**
 * Get the time with AM and PM reversed.
 *
 * @param date - The date to reverse the time meridian.
 * @returns The date with the time meridian reversed.
 */
var getReversedTimeMeridian = exports.getReversedTimeMeridian = function getReversedTimeMeridian(date) {
  var clonedDate = new Date(date.valueOf());
  var hours = (0, _getHours.default)(clonedDate);
  var nextHours = hours >= 12 ? hours - 12 : hours + 12;
  return (0, _setHours.default)(clonedDate, nextHours);
};
var _default = exports.default = getReversedTimeMeridian;