/// <reference types="react" />
/**
 * Virtualized list loses focus when scrolling or clicking options, causing the component to re-render.
 * To solve this problem, we need to refocus on the selected option after the component is re-rendered.
 */
export declare function useFocusVirtualListItem<T extends HTMLElement>(focused?: boolean): import("react").RefObject<T>;
export default useFocusVirtualListItem;
